#ifndef __DIM__
#define __DIM__
//*************************************************************************
//* ==========
//*  Dim Class
//* ==========
//*
//* (Description)
//*    Dim class comprises an array element to build DynArrayX.
//* (Requires)
//* 	TObjArray:
//* (Provides)
//* 	class Dim
//* (Update Recored)
//*    2000/05/18  K.Fujii	Original very primitive version.
//*    2001/05/06  K.Fujii	Replace Expand by AddAtAndExpand to
//*				force fLast to update.
//*
//*************************************************************************
//
#include <TObjArray.h>

class Dim : public TObjArray {
friend class DynArray3;
friend class DynArray2;
public:
   Dim() {}
   virtual ~Dim() { Delete(); }
private:
   virtual TObject * SafeAt(Int_t i) {
      if (i>GetLast()) {
		TObject *dummy = 0;
		AddAtAndExpand(dummy,i+1);
	}
	return At(i);
   }

   ClassDef(Dim,1)		// 1-dim array element
};

#endif




